; pp    p pp
;
;
;  
;
;  p pp
TMR0            EQU     01h
PC              EQU     02h
STATUS          EQU     03h
FSR             EQU     04h
; pp /
CNTRLPORT       EQU     05h
DATAPORT        EQU     06h
;  
SCRATCH         EQU     0Ch
DIGIT           EQU     0Dh
L1              EQU     0Eh
L2              EQU     0Fh
L3              EQU     10h
L0              EQU     11h
;  pp STATUS
C               EQU     0h
DC              EQU     1h
Z               EQU     2h
PD              EQU     3h
TO              EQU     4h
RP              EQU     5h
; p pp
TRISA           EQU     85h
TRISB           EQU     86h
;    p /
INITA           EQU     B'00011000'
INITB           EQU     B'00000000'
;
;  
;
;   
        ORG     0
        GOTO    BEGIN
;
        ORG     100h
BEGIN
;  
        BCF     STATUS,RP    ;  0
        CLRF    CNTRLPORT    ;  CNTRLPORT
        MOVLW   INITA        ;p B'00011000'  pp W
        BSF     STATUS,RP    ;  1
        MOVWF   TRISA        ;      
;  
        BCF     STATUS,RP    ;  0
        CLRF    DATAPORT     ;  DATAPORT
        MOVLW   INITB        ;p B'00000000'  pp W
        BSF     STATUS,RP    ;  1
        MOVWF   TRISB        ;       
;
        BCF     STATUS,RP    ;  0
;
;    pp
       MOVLW    0h
       MOVWF    L1
;       MOVWF    L0
;       MOVWF    L2
;       MOVWF    L3
START
       CALL     LEDN
;       MOVLW    0FFh
;       MOVWF    DATAPORT
       INCF     L1,1
;       CALL     PAUSE
       GOTO     START        ;  
;
LEDN
       MOVLW    0FFh
       MOVWF    DATAPORT
       MOVLW    0h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED0
       MOVLW    1h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED1
       MOVLW    2h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED2
       MOVLW    3h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED3
       MOVLW    4h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED4
       MOVLW    5h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED5
       MOVLW    6h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED6
       MOVLW    7h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED7
       MOVLW    8h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED8
       MOVLW    9h
;       BCF      STATUS,Z
       XORWF    L1,0
       BTFSC    STATUS,Z
       CALL     LED9
       RETURN                ;  
;
LED0
       MOVLW    B'11000000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED1
       MOVLW    B'11111001'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED2
       MOVLW    B'10100100'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED3
       MOVLW    B'10110000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED4
       MOVLW    B'10011001'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED5
       MOVLW    B'10010010'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED6
       MOVLW    B'10000010'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED7
       MOVLW    B'11111000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED8
       MOVLW    B'10000000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
LED9
       MOVLW    B'10010000'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
TOCKA
       MOVLW    B'01111111'
       MOVWF    DATAPORT
       CALL     PAUSE
       RETURN                ;  
;
PAUSE
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    SCRATCH      ;  W  SCRATCH
       MOVLW    0FFh         ; 0FFh   W
       MOVWF    DIGIT        ;  W  DIGIT
LOOP
       DECFSZ   SCRATCH,1    ; SCRATCH  1
       GOTO     LOOP         ;  ,    =0
       DECFSZ   DIGIT,1      ; DIGIT  1
       GOTO     LOOP         ;    LOOP,    =0
       RETURN                ;  
;
 END
;

